﻿"use strict";

var Wingtip = window.Wingtip || {};

Wingtip.ContactList = function () {

    //private members
    var createItem = function (lname, fname, wphone) {
        $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl +
                 "/_api/web/lists/getByTitle('Contacts')/items",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': 'SP.Data.ContactsListItem'
                    },
                    'Title': lname,
                    'FirstName': fname,
                    'WorkPhone': wphone
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            },
            success: function () {
                readAll();;
            },
            error: function (err) {
                alert(JSON.stringify(err));
            }

        });
    },

    readAll = function () {
        $.ajax(
                {
                    url: _spPageContextInfo.webServerRelativeUrl +
                        "/_api/web/lists/getByTitle('Contacts')/items/" +
                        "?$select=Id,FirstName,Title,WorkPhone" +
                        "&$orderby=Title,FirstName",
                    type: "GET",
                    headers: {
                        "accept": "application/json;odata=verbose",
                    },
                    success: function (data) {
                        readAllSuccess(data);
                    },
                    error: function (err) {
                        alert(JSON.stringify(err));
                    }
                }
            );
    },

    readAllSuccess = function (data) {
        var html = [];
        html.push("<table><thead><tr><th>ID</th><th>First Name</th><th>Last Name</th><th>Title</th></tr></thead>");

        var results = data.d.results;

        for(var i=0; i<results.length; i++) {
            html.push("<tr>");
            html.push("<td>");
            html.push(results[i].ID);
            html.push("</td>");
            html.push("<td>");
            html.push(results[i].FirstName);
            html.push("</td>");
            html.push("<td>");
            html.push(results[i].Title);
            html.push("</td>");
            html.push("<td>");
            html.push(results[i].WorkPhone);
            html.push("</td>");
            html.push("</tr>");
        }

        html.push("</table>");
        $('#displayDiv').html(html.join(''));
    },

    updateItem = function (id, lname, fname, wphone) {
        $.ajax(
                {
                    url: _spPageContextInfo.webServerRelativeUrl +
                        "/_api/web/lists/getByTitle('Contacts')/getItemByStringId('" +
                        id + "')",
                    type: "POST",
                    contentType: "application/json;odata=verbose",
                    data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.Data.ContactsListItem'
                        },
                        'Title': lname,
                        'FirstName': fname,
                        'WorkPhone': wphone
                    }),
                    headers: {
                        "accept": "application/json;odata=verbose",
                        "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                        "IF-MATCH": "*",
                        "X-Http-Method": "PATCH"
                    },
                    success: function (data) {
                       readAll();
                    },
                    error: function (err) {
                        alert(JSON.stringify(err));
                    }
                }
            );
    },

    removeItem = function (id) {
        $.ajax(
                {
                    url: _spPageContextInfo.webServerRelativeUrl +
                        "/_api/web/lists/getByTitle('Contacts')/getItemByStringId('" +
                        id + "')",
                    type: "DELETE",
                    headers: {
                        "accept": "application/json;odata=verbose",
                        "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                        "IF-MATCH": "*"
                    },
                    success: function (data) {
                        readAll();
                    },
                    error: function (err) {
                        alert(JSON.stringify(err));
                    }
                }
            );
    }

    //public interface
    return {
        createContact: createItem,
        updateContact: updateItem,
        deleteContact: removeItem
    }

}();

$(document).ready(function () {
    Wingtip.ContactList.createContact("Cox", "Brian", "555-555-5555");
    alert("Contact Created!");
    //Wingtip.ContactList.updateContact(1, "Cox", "Brian", "111-111-1111");
    //alert("Contact Updated!");
    //Wingtip.ContactList.deleteContact(1);
    //alert("Contact Deleted!");
});