﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.Lists = function () {

    var deferreds = new Array(),

    create = function (title, description, template) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var createInfo = new SP.ListCreationInformation();
        createInfo.set_title(title);
        createInfo.set_description(description);
        createInfo.set_templateType(template);
        this.newList = ctx.get_web().get_lists().add(createInfo);
        ctx.load(this.newList);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.newList); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    remove = function (title) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(title)
        ctx.load(list);
        this.oldTitle = title;
        list.deleteObject();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.oldTitle); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    read = function (title) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.list = ctx.get_web().get_lists().getByTitle(title)
        ctx.load(this.list);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.list); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    options = function (title, quickLaunch, attachments, versions) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.list = ctx.get_web().get_lists().getByTitle(title)
        ctx.load(this.list);
        this.list.set_onQuickLaunch(quickLaunch);
        this.list.set_enableAttachments(attachments);
        this.list.set_enableVersioning(versions);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.list); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    getContentType = function (contentTypeId) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.ctype = ctx.get_web().get_contentTypes().getById(contentTypeId);
        ctx.load(this.ctype);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.ctype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    createContentType = function (contentTypeName, description, parentId, local) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var parent = ctx.get_web().get_contentTypes().getById(parentId);
        ctx.load(parent);
        var createInfo = new SP.ContentTypeCreationInformation();
        createInfo.set_name(contentTypeName);
        createInfo.set_description(description);
        createInfo.set_parentContentType(parent);
        if (local === true) {
            this.newCtype = ctx.get_web().get_contentTypes().add(createInfo);
        }
        else {
            this.newCtype = ctx.get_site().get_rootWeb().get_contentTypes().add(createInfo);
        }
        ctx.load(this.newCtype);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.newCtype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    addFieldLink = function (contentTypeId, internalFieldName, local) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var ctype;
        var field;
        if (local === true) {
            ctype = ctx.get_web().get_contentTypes().getById(contentTypeId);
            field = ctx.get_web().get_fields().getByInternalNameOrTitle(internalFieldName);
        }
        else {
            field = ctx.get_site().get_rootWeb().get_fields().getByInternalNameOrTitle(internalFieldName);
            ctype = ctx.get_site().get_rootWeb().get_contentTypes().getById(contentTypeId);
        }
        ctx.load(ctype);
        ctx.load(field);
        var createInfo = new SP.FieldLinkCreationInformation();
        createInfo.set_field(field);
        this.fieldLink = ctype.get_fieldLinks().add(createInfo);
        ctype.update(true);
        ctx.load(this.fieldLink);
        ctx.executeQueryAsync(
        Function.createDelegate(this,
            function () { deferreds[deferreds.length - 1].resolve(this.fieldLink); }),
        Function.createDelegate(this,
            function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    };

    return {
        create: create,
        remove: remove,
        read: read,
        options: options,
        get_contentType: getContentType,
        create_contentType: createContentType,
        add_fieldLink: addFieldLink
    };

}();