﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Client;

namespace ManagedCSOMWeb.Pages
{
    public partial class Caml : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string appWebUrl = Page.Request["SPAppWebUrl"];
            using (ClientContext ctx = new ClientContext(appWebUrl))
            {
                //Read the Site, List, and Items
                ctx.Load(ctx.Web);

                List myList = ctx.Web.Lists.GetByTitle("My List");
                ctx.Load(myList);

                StringBuilder caml = new StringBuilder();
                caml.Append("<View><Query>");
                caml.Append("<Where><Eq><FieldRef Name='Title'/>");
                caml.Append("<Value Type='Text'>New Item</Value></Eq></Where>");
                caml.Append("</Query><RowLimit>100</RowLimit></View>");

                CamlQuery query = new CamlQuery();
                query.ViewXml = caml.ToString();
                Microsoft.SharePoint.Client.ListItemCollection myItems = myList.GetItems(query);
                ctx.Load(myItems);

                ctx.ExecuteQuery();
                Response.Write("<p>Site: " + ctx.Web.Title + "</p>");
                Response.Write("<p>List: " + myList.Title + "</p>");
                Response.Write("<p>Item Count: " + myItems.Count.ToString() + "</p>");
            }

        }
    }
}